Codeforces Round #369 (Div. 2) C. Coloring Trees (DP)

时间:2023-11-28 23:54:02

C. Coloring Trees

time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and color the trees in the park. The trees are numbered with integers from 1 to n from left to right.

Initially, tree i has color ci. ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m, where ci = 0 means that tree i is uncolored.

ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0. They can color each of them them in any of the m colors from 1 to m. Coloring the i-th tree with color j requires exactly pi, jlitres of paint.

The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7, since we can partition the trees into 7 contiguous groups of the same color :{2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.

ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k. They need your help to determine the minimum amount of paint (in litres) needed to finish the job.

Please note that the friends can't color the trees that are already colored.

Input

The first line contains three integers, nm and k (1 ≤ k ≤ n ≤ 100, 1 ≤ m ≤ 100) — the number of trees, number of colors and beauty of the resulting coloring respectively.

The second line contains n integers c1, c2, ..., cn (0 ≤ ci ≤ m), the initial colors of the trees. ci equals to 0 if the tree number i is uncolored, otherwise the i-th tree has color ci.

Then n lines follow. Each of them contains m integers. The j-th number on the i-th of them line denotes pi, j(1 ≤ pi, j ≤ 109) — the amount of litres the friends need to color i-th tree with color jpi, j's are specified even for the initially colored trees, but such trees still can't be colored.

Output

Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print  - 1.

Examples
input
3 2 2
0 0 0
1 2
3 4
5 6
output
10
input
3 2 2
2 1 2
1 3
2 4
3 5
output
-1
input
3 2 2
2 0 0
1 3
2 4
3 5
output
5
input
3 2 3
2 1 2
1 3
2 4
3 5
output
0
Note

In the first sample case, coloring the trees with colors 2, 1, 1 minimizes the amount of paint used, which equals to2 + 3 + 5 = 10. Note that 1, 1, 1 would not be valid because the beauty of such coloring equals to 1 ({1, 1, 1} is a way to group the trees into a single group of the same color).

In the second sample case, all the trees are colored, but the beauty of the coloring is 3, so there is no valid coloring, and the answer is  - 1.

In the last sample case, all the trees are colored and the beauty of the coloring matches k, so no paint is used and the answer is 0.

比赛时这题虽没AC,但是写出来的代码的思想和题解一样,感觉很欣慰,DP开始入门了。

dp[i][j][k],i表示当前第i位,j表示当前颜色,k表示当前种类。

考虑当前第i位,若这一位已填颜色,则考虑dp[i-1][][],讨论一下前面和现在颜色是否相同。

若未填颜色,则j从1枚举到m的颜色,k也从1枚举到K.考虑前一位是否相同即可。

 #include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
using namespace std;
typedef long long ll;
const ll inf = 0x3f3f3f3f3f3f3f3f;
const int maxn = ;
ll dp[maxn][maxn][maxn];
int c[maxn];
int col[maxn][maxn];
int main()
{
int n,m,k;
cin>>n>>m>>k;
for(int i=;i<=n;i++) scanf("%d",&c[i]);
for(int i=;i<=n;i++)
{
for(int j=;j<=m;j++)
{
scanf("%d",&col[i][j]);
}
}
memset(dp,inf,sizeof(dp));
if(c[]) dp[][c[]][] = ;
else
{
for(int j=;j<=m;j++) dp[][j][] = col[][j];
}
for(int i=;i<=n;i++)
{
if(c[i])
{
for(int p=;p<=k;p++)
{
dp[i][c[i]][p] = min(dp[i][c[i]][p],dp[i-][c[i]][p]);
for(int q=;q<=m;q++)
{
if(q!=c[i]) dp[i][c[i]][p] = min(dp[i][c[i]][p],dp[i-][q][p-]);
}
}
}
else
{
for(int p=;p<=m;p++)
{
for(int q=;q<=k;q++)
{
dp[i][p][q] = min(dp[i][p][q],dp[i-][p][q]+col[i][p]);
for(int la=;la<=m;la++)
{
if(p!=la) dp[i][p][q] = min(dp[i][p][q],dp[i-][la][q-]+col[i][p]);
}
}
}
}
}
ll ans = inf;
for(int j=;j<=m;j++)
{
ans = min(ans,dp[n][j][k]);
}
printf("%I64d\n",ans==inf?-:ans);
return ;
}